static char sccsid[]="%Z% %M% %I% %E% %U%";
/************************************************/
/*												*/
/*	akxsRb.c									*/
/*												*/
/*		coded by A.Kobayashi 2010.5.20			*/
/*												*/
/************************************************/
#include "akxcommon.h"
#include <math.h>

/* 01 */
tdtRB_CTL *akxs_rb_new2(lBS,lRM,m_alloc,pConstCt)
int lBS,lRM;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	tdtRB_CTL *pCt;
	tdtRB_CHAIN *p1,*p2;
	int ret;

	pCt = (tdtRB_CTL *)akxm_malloc_constct(m_alloc,pConstCt,sizeof(tdtRB_CTL));
	if (!pCt) return NULL;
	memset(pCt,0,sizeof(tdtRB_CTL));
	pCt->rb_bfsz = lBS;
	pCt->rb_max = lRM;
	ret = akxm_malloc_constct_pp(m_alloc,pConstCt,sizeof(tdtRB_CHAIN),(char **)&p1);
	if (!p1) {
		if (!ret) Free(pCt);
		return NULL;
	}
	pCt->rb_cur = pCt->rb_waddr = pCt->rb_raddr = p1;
	p1->rbc_buf = NULL;
	ret = akxm_malloc_constct_pp(m_alloc,pConstCt,sizeof(tdtRB_CHAIN),(char **)&p2);
	if (!p2) {
		if (!ret) {
			Free(pCt);
			Free(p1);
		}
		return NULL;
	}
	pCt->rb_wpriv = p2;
	p2->rbc_buf = NULL;
	p1->rbc_next = p2;
	p2->rbc_next = p1;
	pCt->rb_num = 2;
	pCt->rb_malloc = m_alloc;
	pCt->rb_constct = pConstCt;
/*
printf("akxs_rb_new2: p1=%08x p2=%08x\n",p1,p2);
*/
	return pCt;
}

/* 02 */
tdtRB_CTL *akxs_rb_new(lBS,lRM)
int lBS,lRM;
{
	return akxs_rb_new2(lBS,lRM,NULL,NULL);
}

/* 03 */
tdtRB_CTL *akxs_rb_init(lBS,lRM)
int lBS,lRM;
{
	return akxs_rb_new2(lBS,lRM,NULL,NULL);
}

/* 04 */
char *akxs_rb_get(pCt)
tdtRB_CTL *pCt;
{
	char *p;

	p = NULL;
	if (pCt) {
		if (pCt->rb_used > 0) p = pCt->rb_raddr->rbc_buf;
	}
	return p;
}

/* 05 */
char *akxs_rb_get_n(pCt)
tdtRB_CTL *pCt;
{
	char *p;
	tdtRB_CHAIN *pr;

	p = NULL;
	if (pCt) {
		if (pCt->rb_used > 0) {
			if (pr = pCt->rb_raddr) {
				if (p=pr->rbc_buf) {
					pr->rbc_buf = NULL;
					pCt->rb_raddr = pr->rbc_next;
					pCt->rb_used--;
				}
/*
printf("akxs_rb_get_n: pr=%08x p=%08x\n",pr,p);
*/
				pCt->rb_cur = pCt->rb_raddr;
				pCt->rb_pos = 0;
			}
		}
	}
	return p;
}

/* 06 */
char *akxs_rb_set_n(pCt, addr)
tdtRB_CTL *pCt;
char *addr;
{
	tdtRB_CHAIN *pw, *pn, *pp;
/*
printf("akxs_rb_set_n: pCt=%08x addr=%08x\n",pCt,addr);
*/
	if (!pCt || !addr) return NULL;

	if (!(pw = pCt->rb_waddr)) return NULL;
	if (pw->rbc_buf) {
		pn = (tdtRB_CHAIN *)akxm_malloc_constct(pCt->rb_malloc,pCt->rb_constct,sizeof(tdtRB_CHAIN));
		if (!pn) return NULL;
		pp = pCt->rb_wpriv;
		pCt->rb_waddr = pp->rbc_next = pn;
		pn->rbc_next = pw;
		pw = pCt->rb_waddr;
		pCt->rb_num++;
	}
/*
printf("akxs_rb_set_n: pw=%08x pw->rbc_next=%08x\n",pw,pw->rbc_next);
printf("akxs_rb_set_n: pCt->rb_raddr=%08x pCt->rb_wpriv=%08x\n",pCt->rb_raddr,pCt->rb_wpriv);
*/
	pw->rbc_buf = addr;
	pCt->rb_waddr = pw->rbc_next;
	pCt->rb_wpriv = pw;
	pCt->rb_used++;
	return addr;
}

/* 07 */
int akxs_rb_free(pCt)
tdtRB_CTL *pCt;
{
	tdtRB_CHAIN *pw, *pn, *pp;
	char *(*m_alloc)();

	if (!pCt) return -1;
	m_alloc = pCt->rb_malloc;
	if (pp = pCt->rb_wpriv) {
		pw = pp->rbc_next;
		pp->rbc_next = NULL;
		while (pw) {
			pn = pw->rbc_next;
			if (!m_alloc) Free(pw);
			pw = pn;
		}
	}
	if (!m_alloc) Free(pCt);
	return 0;
}

/* 08 */
int akxs_rb_buf_free(pCt)
tdtRB_CTL *pCt;
{
	char *p;
	char *(*m_alloc)();

	if (!pCt) return -1;

	m_alloc = pCt->rb_malloc;
	while (p=akxs_rb_get_n(pCt)) {
		if (!m_alloc) Free(p);
	}
	return 0;
}

/* 09 */
int akxs_rb_all_free(pCt)
tdtRB_CTL *pCt;
{
	int  iRc;

	if (!(iRc = akxs_rb_buf_free(pCt))) iRc = akxs_rb_free(pCt);

	return iRc;
}

/* 10 */
char *akxs_rb_set_t(pCt, addr)
tdtRB_CTL *pCt;
char *addr;
{
	tdtRB_CHAIN *pw, *pn, *pp;

	if (!pCt || !addr) return NULL;
	if (!akxs_rb_get(pCt)) return akxs_rb_set_n(pCt,addr);

	pw = pCt->rb_waddr;
	while ((pp=pw->rbc_next) != pCt->rb_raddr) {
		pw = pp;
	}

	if (pw->rbc_buf) {
		pn = (tdtRB_CHAIN *)akxm_malloc_constct(pCt->rb_malloc,pCt->rb_constct,sizeof(tdtRB_CHAIN));
		if (!pn) return NULL;
		pw->rbc_next = pn;
		pn->rbc_next = pp;
		pw = pn;
		pCt->rb_num++;
	}
	pw->rbc_buf = addr;
	if (pCt->rb_raddr == pCt->rb_waddr) {
		pCt->rb_waddr = pw;
	}
/*
printf("akxs_rb_set_t: pw=%08x addr=%08x\n",pw,addr);
*/
	pCt->rb_raddr = pw;
	pCt->rb_used++;
	pCt->rb_cur = pCt->rb_raddr;
	pCt->rb_pos = 0;
	return addr;
}

/* 11 */
char *akxs_rb_read(pCt, cmd)
tdtRB_CTL *pCt;
int cmd;
{
	tdtRB_CHAIN *pr;
	char *p=NULL;

	if (pCt) {
		if (!cmd) {
			pr = pCt->rb_raddr;
			pCt->rb_pos = 0;
		}
		else {
			if (pCt->rb_pos >= pCt->rb_used) return NULL;
			if (pCt->rb_pos) {
				pr = pCt->rb_cur;
				pCt->rb_cur = pr->rbc_next;
			}
			else pCt->rb_cur = pCt->rb_raddr;
			pr = pCt->rb_cur;
			pCt->rb_pos++;
		}
		p = pr->rbc_buf;
	}
	return p;
}

/* 12 */
int akxs_rb_exchg(pCt1, pCt2, opt)
tdtRB_CTL *pCt1,*pCt2;
int opt;
{
	tdtRB_CTL tCtW;

	if (!pCt1 || !pCt2) return -1;
	tCtW  = *pCt1;
	*pCt1 = *pCt2;
	*pCt2 = tCtW;
	return 0;
}

/* 13 */
int akxs_rb_used(pCt)
tdtRB_CTL *pCt;
{
	if (!pCt) return -1;
	return pCt->rb_used;
}

/* 14 */
char *akxs_rb_srch(pCt, addr, compar)
tdtRB_CTL *pCt;
char *addr;
int (*compar)();
{
	int f;
	tdtRB_CHAIN *pr;
	char *p;

	if (!pCt || !addr) return NULL;
	if (!compar) compar = strcmp;
	pr = pCt->rb_raddr;
	while (p=pr->rbc_buf) {
		if (!compar(addr,p)) return p;
		pr = pr->rbc_next;
		if (pr == pCt->rb_waddr) break;
	}
	return NULL;
}

/************************************************/
/*												*/
/*		List									*/
/*	21											*/
/************************************************/
tdtRB_CTL *akxs_list_new2(lBS,lRM,m_alloc,pConstCt)
int lBS,lRM;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	tdtRB_CTL *pCt;

	pCt = (tdtRB_CTL *)akxm_malloc_constct(m_alloc,pConstCt,sizeof(tdtRB_CTL));
	if (!pCt) return NULL;
	memset(pCt,0,sizeof(tdtRB_CTL));
	pCt->rb_bfsz = lBS;
	pCt->rb_max = lRM;
	pCt->rb_malloc = m_alloc;
	return pCt;
}

/* 22 */
tdtRB_CTL *akxs_list_new(lBS,lRM)
int lBS,lRM;
{
	return akxs_list_new2(lBS,lRM,NULL,NULL);
}

/* 23 */
int akxs_list_free(pCt,free_func)
tdtRB_CTL *pCt;
int (*free_func)();
{
	tdtRB_CHAIN *pw, *pn, *pp;
	char *p;
	char *(*m_alloc)();

	if (!pCt) return -1;
	m_alloc = pCt->rb_malloc;
	while (akxs_list_get(pCt,&p) > 0) {
		if (p) {
			if (free_func) free_func(p);
			else if (!m_alloc) Free(p);
		}
	}
	if (!m_alloc) Free(pCt);
	return 0;
}

/* 24 */
int akxs_list_get(pCt,pp)
tdtRB_CTL *pCt;
char **pp;
{
	tdtRB_CHAIN *pr;

	if (!pCt) return -1;
	
	if (pr = pCt->rb_raddr) {
		*pp = pr->rbc_buf;
		pCt->rb_raddr = pr->rbc_next;
		pCt->rb_used--;
		if (pr == pCt->rb_waddr) pCt->rb_waddr = NULL;
		Free(pr);
		return 1;
	}
	else return 0;
}

/* 25 */
int akxs_list_set(pCt, addr)
tdtRB_CTL *pCt;
char *addr;
{
	tdtRB_CHAIN *pw, *pn;

	if (!pCt) return -1;

	pn = (tdtRB_CHAIN *)akxm_malloc_constct(pCt->rb_malloc,pCt->rb_constct,sizeof(tdtRB_CHAIN));
	if (!pn) return 0;
	pn->rbc_buf = addr;
	pn->rbc_next = NULL;
	if (pw = pCt->rb_waddr) pw->rbc_next = pn;
	else pCt->rb_raddr = pn;	/* pCt->rb_waddrNULLłȂƂ́ApCt->rb_raddrNULLłȂ̂łŗǂ */
	pCt->rb_waddr = pn;
	pCt->rb_used++;
	return 1;
}

/* 26 */
int akxs_list_srch(pCt, addr, compar, opt)
tdtRB_CTL *pCt;
char *addr;
int (*compar)();
int opt;
{
	int f;
	tdtRB_CHAIN *pr,*pre;
	char *p;

	if (!pCt) return -1;
	pre = NULL;
	pr = pCt->rb_raddr;
	while (pr) {
		if (compar) f = !compar(addr,pr->rbc_buf);
		else f = (addr == pr->rbc_buf);
		if (f) {
			if (opt) {
				if (pre) pre->rbc_next = pr->rbc_next;
				else pCt->rb_raddr = pr->rbc_next;
				if (!pr->rbc_next) pCt->rb_waddr = pre;
				pCt->rb_used--;
			}
			pCt->rb_cur = pr;
			return 1;
		}
		pre = pr;
		pr = pr->rbc_next;
	}
	return 0;
}

/* 27 */
int akxs_list_read(pCt, cmd, pp)
tdtRB_CTL *pCt;
int     cmd;
char   **pp;
{
	tdtRB_CHAIN *pr;

	if (!pCt) return -1;

	if (!cmd) {
		pCt->rb_cur = NULL;
	}
	else {
		if (cmd > 0) {
			if (pr = pCt->rb_cur) pr = pr->rbc_next;
			else pr = pCt->rb_raddr;
		}
		else {
			if (!(pr = pCt->rb_cur)) pr = pCt->rb_raddr;
		}
		if (pr) {
			pCt->rb_cur = pr;
			*pp = pr->rbc_buf;
			return 1;
		}
	}
	return 0;
}

/************************************************/
/*												*/
/*		Stack									*/
/*												*/
/************************************************/
/********1*********2*********3*********4*********5*********6*********/
/*	@\ : X^bN\̂								31	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*				max_stack	: X^bN							*/
/*		   OUT: stack		: X^bN\̂̃o				*/
/*								stack->wdmax = max_stack			*/
/*								stack->sp = 0						*/
/*								((char **)stack->wd)[] = NULL		*/
/*	ԋp : = 0 													*/
/*		   =-2 max_stack <= 0										*/
/*	쐬 : 2014/12/01 Akito Kobayashi								*/
/*	XV :															*/
/********************************************************************/
int akxs_stack_init(SSPL_S *stack,int max_stack)
{
	int ret;

	ret = 0;
	if (max_stack <= 0) ret -= 2;
	if (ret == 0) {
		stack->wdmax = max_stack;
		stack->sp = 0;
		mem_set_addr((char **)stack->wd,NULL,max_stack);
	}
	return ret;
}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ : X^bN\̂쐬A						32	*/
/*	 : IN : max_stack	: X^bN							*/
/*		   OUT: stack		: X^bN\̂̃o				*/
/*								stack->wdmax = max_stack			*/
/*								stack->sp = 0						*/
/*								((char **)stack->wd)[] = NULL		*/
/*	ԋp : != NULL 												*/
/*		   =  NULL G[											*/
/*	쐬 : 2020/01/27 Akito Kobayashi								*/
/*	XV :															*/
/********************************************************************/
SSPL_S *akxs_stack_new(int max_stack)
{
	SSPL_S *stack;
	int ret;

	stack = NULL;
	if (max_stack > 0) {
		if (stack = (SSPL_S *)Malloc(sizeof(SSPL_S))) {
			if (stack->wd = Malloc(sizeof(char *)*max_stack)) {
				akxs_stack_init(stack,max_stack);
			}
			else {
				Free(stack);
				stack = NULL;
			}
		}
	}
	return stack;
}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ : X^bN\̂J								33	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*	ԋp : = 0 													*/
/*		   =-1 stack = NULL											*/
/*	쐬 : 2020/01/27 Akito Kobayashi								*/
/*	XV :															*/
/********************************************************************/
int akxs_stack_free(SSPL_S *stack)
{
	int ret;

	ret = 0;
	if (stack) {
		Free(stack->wd);
		Free(stack);
	}
	else ret = -1;
	return ret;
}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ X^bNɐς											34	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*				val			: X^bNɐςޒl						*/
/*		   OUT: stack		: X^bN\̂̃o				*/
/*							  ((char **)stack->wd)[stack->sp] = val */
/*							  stack->sp++							*/
/*	ԋp :	= 0 : 												*/
/*			=-1 : stack = NULL										*/
/*			=-4 : X^bNI[o									*/
/*	쐬 :2014/12/01 AkitoKobayashi									*/
/*	XV :															*/
/********************************************************************/
int akxs_stack_push(SSPL_S *stack,char *val)
{
	int ret;
	char **p;

	ret = 0;
	if (stack) {
		if (stack->sp >= stack->wdmax)
			ret = -4;
		else {
			p = (char **)(stack->wd);
			p[stack->sp] = val;
			stack->sp++;
		}
	}
	else ret = -1;
	return ret;
}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ : X^bN̂A܂́AX^bNo		35	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*				val			: X^bN̒lւ̎Q					*/
/*				isPeek		: PeektO							*/
/*								= 0 : X^bNo			*/
/*								!=0 : X^bN̂				*/
/*		   OUT: stack		: X^bN\̂̃o				*/
/*							  X^bNoƤ				*/
/*								stack->sp--							*/
/*	ԋp :	= 0 : 												*/
/*			=-1 : stack = NULL										*/
/*			=-8 : X^bN͋										*/
/*	쐬 : 2014/12/01 Akito Kobayashi								*/
/*	XV :															*/
/********************************************************************/
static int _PopPeekStack(SSPL_S *stack,char **val,int isPeek)
{
	int ret;
	char **p;

	ret = 0;
	if (stack && val) {
		if (stack->sp <= 0)
			ret = -8;
		else {
			p = (char **)(stack->wd);
			*val = p[stack->sp - 1];
			if (isPeek == 0) stack->sp--;
		}
	}
	else ret = -1;
	return ret;
}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ : X^bNo									36	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*				val			: X^bN̒lւ̎Q					*/
/*		   OUT: val			: ol							*/
/*				stack		: X^bN\̂̃o				*/
/*								stack->sp--							*/
/*	ԋp :	= 0 : 												*/
/*			=-1 : stack = NULL										*/
/*			=-8 : X^bN͋										*/
/*	쐬 : 2014/12/01 Akito Kobayashi								*/
/*	XV :															*/
/********************************************************************/
int akxs_stack_pop(SSPL_S *stack,char **val)
{

	return _PopPeekStack(stack, val, 0);

}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ : X^bN̂										37	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*				val			: X^bN̒lւ̎Q					*/
/*		   OUT: val			: ̂l							*/
/*	ԋp :	= 0 : 												*/
/*			=-1 : stack = NULL										*/
/*			=-8 : X^bN͋										*/
/*	쐬 : 2014/12/01 Akito Kobayashi								*/
/*	XV :															*/
/********************************************************************/
int akxs_stack_peek(SSPL_S *stack,char **val)
{

	return _PopPeekStack(stack, val, 1);

}

/********1*********2*********3*********4*********5*********6*********/
/*	@\ :X^bNT[`AȂΓo^					38	*/
/*	 : IN : stack		: X^bN\̂ւ̎Q				*/
/*				val			: X^bNɓo^l					*/
/*				Optional 	: opt 0x01=1 : o^					*/
/*		   OUT: stack		: X^bN\̂̃o				*/
/*							  o^Ƃ́A						*/
/*							  ((char **)stack->wd)[stack->sp] = val */
/*							  stack->sp++							*/
/*	ԋp :	> 0 : o^ʒu + 1										*/
/*			=-4 : X^bNI[o									*/
/*			=-8 : X^bN͋										*/
/*	쐬 : 2018/03/15 Aki to Kobayashi								*/
/*	XV :															*/
/********************************************************************/
int akxs_stack_srch(SSPL_S *stack,char *val,int opt)
{
	int ret,i;
	char **p;

	ret = 0;
	if (stack && val) {
		p = (char **)(stack->wd);
		for (i = 0; i< stack->sp - 1; i++) {
			if (p[i] == val) {
				ret = i + 1;
				break;
			}
		}
		if (opt & 0x01) ret = akxs_stack_push(stack, val);
	}
	else ret = -1;
	return ret;
}

/****************************************/
/*	41									*/
/*	`FbN͂Ȃ				*/
/****************************************/
MCAT2 *akxs_layer_new(imax,m_alloc,pConstCt)
int imax;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	/* 2022.10.30 */
	return akxs_mseq_new(sizeof(long),-imax,m_alloc,pConstCt);
}

/****************************************/
/*	42									*/
/****************************************/
int akxs_layer_i(mcat)
MCAT2 *mcat;
{
	/* 2022.10.30 */
	return akxs_mseq_i(mcat);
}

/****************************************/
/*	43									*/
/*	ilay  : R[hԍ(0擪)		*/
/*			<0 : ɒǉ			*/
/****************************************/
int akxs_layer_set(mcat,ilay,lVal)
MCAT2 *mcat;
int ilay;
long lVal;
{
	/* 2022.10.30 */
	return akxs_mseq_set(mcat,ilay+1,&lVal);
}

/****************************************/
/*	44									*/
/****************************************/
int akxs_layer_r(mcat,lVal)
MCAT2 *mcat;
long lVal;
{
	/* 2022.10.30 */
	return akxs_mseq_r(mcat,&lVal);
}

/****************************************/
/*	45									*/
/****************************************/
int akxs_layer_s(mcat,lVal)
MCAT2 *mcat;
long lVal;
{
	int ii;

	if (!(ii=akxs_layer_r(mcat,lVal))) {
		ii = akxs_layer_set(mcat,-1,lVal);
	}
	return ii;
}

/********************************************/
/*	46										*/
/*	ilay  : >=1 : 폜郌R[hԍ		*/
/*			<=0 : 폜			*/
/********************************************/
int akxs_layer_del(mcat,ilay,plVal)
MCAT2 *mcat;
int ilay;
long *plVal;
{
	return akxs_mseq_del(mcat,ilay,plVal);
}

/*	51	*/
/********1*********2*********3*********4*********5*********6*********7***/
/* @\ : Œ蒷R[hǗ\̂𐶐						*/
/*  : IN  : mlen		: R[h(L[{f[^)(oCg)		*/
/*				imax_rec	: ő僌R[h							*/
/*							  imax<=0̂Ƃ́A`FbNȂ		*/
/*							  imax=0̂Ƃ́Aimax=USHRT_MAXƂ		*/
/*							  imax<0̂Ƃ́Aimax=-imaxƂ			*/
/*							  ́Amlen*D_LEAF_ITEM_NUMoCg	*/
/*							  ubNŊg						*/
/*				dlen 		: f[^(oCg)						*/
/*				m_alloc		: mۊ֐(=NULL:mallocg)		*/
/*				pConstCt	: ConstCtւ̃|C^(=NULL:ConstCtgp)	*/
/*		  OUT : Ȃ													*/
/* ԋp :	<>MULL : Ǘ\̂ւ̃|C^						*/
/*			= NULL : G[												*/
/* 쐬 : 2023/05/20 Aki to Kobayashi									*/
/* XV : 2024/05/19 Aki to Kobayashi									*/
/* XV : 2024/05/26 Aki to Kobayashi									*/
/************************************************************************/
MCAT2 *akxs_xmseq2_new(mlen,imax_rec,dlen,m_alloc,pConstCt)
int mlen,imax_rec,dlen;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	MCAT2_ELM *p;
	int s_min,num,extent,shift,imax,int_max_mlen;
	double d_max;
/*
printf("akxs_xmseq2_new:Enter mlen=%d imax_rec=%d dlen=%d m_alloc=%s pConstCt=%s\n",
mlen,imax_rec,dlen,nval1x(m_alloc),nval1x(pConstCt));
*/
	if (dlen < 0) dlen = 0;
	else if (mlen<=0 || dlen>mlen) return NULL;

	if (!(p=(MCAT2_ELM *)akxm_malloc_constct(m_alloc,pConstCt,sizeof(MCAT2_ELM)))) {
		errno = -185215101;
		return NULL;
	}
	memset(p,0,sizeof(MCAT2_ELM));
#if 1	/* 2024.6.1 */
	imax = imax_rec;
	if (imax <= 0) {
		imax = -imax;
		if (imax < 5) imax = 10;	/* 256 */
	}
	else {
		int_max_mlen = INT_MAX/mlen;
		if (imax > int_max_mlen) imax = int_max_mlen;
	}
	if (imax_rec) p->mc_maxrec = imax;
/*
	if (imax_rec > 0) extent = 0;
	else {
		if (imax <= 10) extent = imax;
		else if (imax <= 100) extent = 10;
		else extent = imax/10;;
	}
*/
#else
	if (imax <= 0) imax = -imax;
	else p->mc_maxrec = imax;
	if (!imax) imax = USHRT_MAX;
#endif
#if 1	/* 2024.5.26 */
	num = D_LEAF_ITEM_NUM;
	shift = D_LEAF_BIT_SHIFT;
	s_min = num*num*USHRT_MAX*2;
	if (imax >= s_min) {
		d_max = imax;
		num = sqrt(d_max/(USHRT_MAX*2.0)) + 0.5;
		if (num <= D_LEAF_ITEM_NUM) {
			;
		}
		else if (num <= D_LEAF_ITEM_NUM*2) {
			num = D_LEAF_ITEM_NUM*2;
			shift = D_LEAF_BIT_SHIFT + 1;
		}
		else {
			num = D_LEAF_ITEM_NUM*4;
			shift = D_LEAF_BIT_SHIFT + 2;
		}
		extent = num*2;
	}
#if 1	/* 2024.6.1 */
	else if (imax_rec < 0) {
		if (imax <= 10) extent = imax;
		else if (imax <= 100) extent = 10;
		else {
			extent = imax/10;
			if (extent > USHRT_MAX) extent = 0;
		}
	}
#endif
	else {
		extent = imax/(USHRT_MAX*num);
		if (extent <= 0) extent = 2;
	}
	p->mc_id[0] = shift;
	p->mc_id[1] = num;
	p->mc_extlen = extent;
#else
	p->mc_extlen = X_MAX(imax/10,10);
#endif
	p->mc_malloc = m_alloc;
	p->mc_constct = pConstCt;
	p->mc_mlen = mlen;
	p->mc_resv = dlen;
/*
printf("akxs_xmseq2_new: mc_maxrec=%d exten=%d num=%d shift=%d\n",p->mc_maxrec,extent,num,shift);
*/
	return (MCAT2 *)p;
}

/****************************************/
/*	52									*/
/****************************************/
MCAT2 *akxs_xmseq_new(mlen,imax,m_alloc,pConstCt)
int mlen,imax;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	return akxs_xmseq2_new(mlen,imax,0,m_alloc,pConstCt);
}

/****************************************/
/*	53									*/
/****************************************/
int akxs_xmseq_i(mcat)
MCAT2 *mcat;
{
	int ret;

	ret = 0;
	if (mcat) mcat->mc_ipos = 0;
	else ret = -1;
	return ret;
}

/*	54	*/
/********1*********2*********3*********4*********5*********6*********7***/
/* @\ : ɃR[hZbg								*/
/*  : IN  : mcat	: Œ蒷R[hǗ\̂ւ̃|C^	*/
/*				ilay	: ݒʒu										*/
/*						  <= 0 : ɒǉ							*/
/*						  >  0 : R[hʒu(1擪)					*/
/*								 Zbgςݍő僌R[hԍz		*/
/*								 Ƃ́Ailay܂ރubN܂		*/
/*								 g								*/
/*				mem 	: Zbg郌R[h							*/
/*		  OUT : mcat	:												*/
/*							mc_extlen : ̃|C^z̊gvf	*/
/*							mc_alclen : |C^z̗vf			*/
/*							mc_bufp   ; |C^z̈̐擪AhX	*/
/*							mc_ipos   : R[hʒu(1擪)		*/
/* ԋp : > 0 : ZbgR[hԍ(1擪)							*/
/*		  < 0 : G[													*/
/* 쐬 : 2023/05/20 Aki to Kobayashi									*/
/* XV : 2024/05/19 Aki to Kobayashi									*/
/* XV : 2024/05/26 Aki to Kobayashi									*/
/************************************************************************/
int akxs_xmseq_set(mcat,ilay,mem)
MCAT2_ELM *mcat;
int ilay;
char *mem;
{
	int ii,extlen,alen,mlen,pos,imax,alclen,ix,ir,ipos,num,shift,ih,ilay0;
	char *p,*pp,**pa;
	XHASHB *xha;

	if (!mcat || !mem) return -1;
/*
printf("akxs_xmseq_set:Enter ilay=%d\n",ilay);
*/
	shift= mcat->mc_id[0];
	num  = mcat->mc_id[1];
	mlen = mcat->mc_mlen;
	imax = mcat->mc_maxrec;
	/* 2024.5.19 */
	ilay0 = ilay;
	ipos =  mcat->mc_ipos;
/*
printf("akxs_xmseq_set: imax=%d ipos=%d\n",imax,ipos);
*/
	if (ilay <= 0) ilay = ipos;
	if (imax && ilay>imax) return -2;
	if (ilay0 > 0) ilay = ilay0 - 1;
/*	ix = ilay/num + 1;	*/
/*	ix = (ilay>>D_LEAF_BIT_SHIFT) + 1;	*/
	ix = (ilay>>shift) + 1;
	if (!(p=akxtleafget(mcat,ix,num,1))) return -1;
/*	ir = ilay % num;	*/
	ir = ilay & (num-1);
/*
printf("akxs_xmseq_set: ir=%d\n",ir);
*/
	p += mlen*ir;
	memcpy(p,mem,mlen);
	ii = ilay + 1;
	pa = (char **)mcat->mc_bufp;
	if (xha = (XHASHB *)pa[0]) {
		ih = akxs_xhash2(xha,'S',mem,&ii);
	}
	if (ii > ipos) {
/*
printf("akxs_xmseq_set: ii=%d\n",ii);
*/
		mcat->mc_ipos = ii;
	}
	return ii;
}

/* 55 */
/************************************************/
/*		ilay : R[ḧʒu(擪=0)w肷	*/
/************************************************/
static char *_get_rec(mcat,ilay)
MCAT2 *mcat;
int ilay;
{
	int mlen,ix,ir,num,shift;
	char *p;

	shift= mcat->mc_id[0];
	num  = mcat->mc_id[1];
	p = NULL;
	if (ilay >= 0) {
		ix = (ilay>>shift) + 1;
		if (ix < mcat->mc_ipos) {
			if (p = akxtleafget(mcat,ix,0,0)) {
				mlen = mcat->mc_mlen;
				ir = ilay & (num-1);
				p += mlen*ir;
			}
		}
	}
	return p;
}

/*	56	*/
/********1*********2*********3*********4*********5*********6*********/
/* @\ : ɎwL[ŃT[`							*/
/*  : IN  : mcat : Œ蒷R[hǗ\̂ւ̃|C^	*/
/*				mem  : L[   : T[`L[ݒ肷				*/
/*					   f[^ : f[^Ԃ					*/
/*				opt  : 												*/
/*					  =0x01 : ȂƂmem̃f[^	*/
/*							  NA							*/
/*					  =0x02 : Ƃf[^ǂݍ܂Ȃ	*/
/*					  =0x10 : strcmpA								*/
/* ԋp : > 0 : R[hԍ(1擪)						*/
/*		  = 0 : Ȃ									*/
/*		  < 0 : G[												*/
/* 쐬 : 2023/05/20 Aki to Kobayashi								*/
/* XV : 2024/05/19 Aki to Kobayashi								*/
/* XV : 2024/05/26 Aki to Kobayashi								*/
/********************************************************************/
int akxs_xmseq_r2(mcat,mem,opt)
MCAT2_ELM *mcat;
char *mem;
int opt;
{
	int i,ii,imax,ipos,mlen,dlen,klen,opt10,match,ix,num,k,maxrec,*pm;
	long ih;
	char *p,**pa;
	XHASHB *xha;

	if (!mcat || !mem) return -1;
/*
printf("akxs_xmseq_r2:Enter opt=%02x\n",opt);
*/
	opt10 = opt & 0x10;
	num  = mcat->mc_id[1];
	mlen = mcat->mc_mlen;
	dlen = mcat->mc_resv;
	klen = mlen - dlen;
	imax = mcat->mc_alclen;
	maxrec = mcat->mc_ipos;
/*
printf("akxs_xmseq_r2: maxrec=%d\n",maxrec);
*/
	/* 2024.5.26 */
	if (maxrec >= 50) {
		pa = (char **)mcat->mc_bufp;
		if (!(xha = (XHASHB *)pa[0])) {
			if (!(xha=akxs_xhashm_new2(klen,maxrec,0,sizeof(int),0x08,
			                           mcat->mc_malloc,mcat->mc_constct))) return -1;
			pa[0] = (char *)xha;
			k = 0;
			for (ix=1;ix<imax;ix++) {
				if (!(p = akxtleafget(mcat,ix,num,0))) continue;
				for (i=0;i<num;i++) {
					if (k >= maxrec) break;
					k++;
				/*	pm = (int *)p;	*/
					ih = akxs_xhash2(xha,'S',p,&k);	/* R[hԍ(擪=1)ۑ */
/*
printf("akxs_xmseq_r2:S k=%d ih=%d\n",k,ih);
*/
					if (ih <= 0) {
						k = maxrec;
						break;
					}
					p += mlen;
				}
				if (k >= maxrec) break;
			}
		}
		ih = akxs_xhash2(xha,'R',mem,&p);
/*
printf("akxs_xmseq_r2:R ih=%d\n",ih);
*/
		if (ih > 0) {
			memcpy(&ii,p,sizeof(int));
/*
printf("akxs_xmseq_r2: ii=%d\n",ii);
*/
			if (!(p = _get_rec(mcat,ii-1))) ii = 0;
		}
		else ii = 0;
	}
	else {
		k = ii = 0;
		/* 2024.5.19 */
		for (ix=1;ix<imax;ix++) {
			if (!(p = akxtleafget(mcat,ix,num,0))) continue;
			for (i=0;i<num;i++) {
				if (k >= maxrec) break;
				if (opt10) match = !strcmp(p,mem);
				else match = !memcmp(p,mem,klen);
				if (match) {
/*
printf("akxs_xmseq_r2: i=%d\n",i);
*/
					ii = i + 1;
					break;
				}
				p += mlen;
				k++;
			}
			if (k > maxrec) break;
			if (ii > 0) {
				ii = (ix-1)*num + ii;
				break;
			}
		}
	}
	if (dlen > 0) {
		if (ii > 0) {
			if (!(opt & 0x02)) memcpy(mem+klen,p+klen,dlen);
		}
		else if (opt & 0x01) memset(mem+klen,0,dlen);
	}
/*
printf("akxs_xmseq_r2:Exit ix=%d ii=%d\n",ix,ii);
*/
	return ii;
}

/* 57 */
/********1*********2*********3*********4*********5***/
/*		mem	: L[   : T[`L[ݒ肷		*/
/* ԋp : > 0 : R[hԍ(1擪)		*/
/*				f[^Ԃ						*/
/*		  = 0 : Ȃ					*/
/*				f[^NA				*/
/*		  < 0 : G[								*/
/****************************************************/
int akxs_xmseq_r(mcat,mem)
MCAT2 *mcat;
char *mem;
{
	return akxs_mseq_r2(mcat,mem,1);
}

/****************************************/
/*	58									*/
/****************************************/
int akxs_xmseq_s(mcat,mem)
MCAT2 *mcat;
char *mem;
{
	int ii;

	if (!mcat || !mem) return -1;

	if (!(ii=akxs_mseq_r2(mcat,mem,2))) ii = -1;
	ii = akxs_mseq_set(mcat,ii,mem);
	return ii;
}

/*	59	*/
/********1*********2*********3*********4*********5*******/
/*  : IN  : ilay	: 擾ʒu						*/
/*						  <= 0 : ̃R[h			*/
/*						  >  0 : R[hʒu(1擪)	*/
/********************************************************/
int akxs_xmseq_get(mcat,ilay,mem)
MCAT2 *mcat;
int ilay;
char *mem;
{
	int ret,mlen,ix,ir,num,shift;
	char *p;

	if (!mcat || !mem) return -1;

	if (ilay <= 0) ilay = mcat->mc_ipos;
	ilay--;
	/* 2024.5.19 */
	ret = -1;
	/* 2024.5.26 */
	if (p = _get_rec(mcat,ilay)) {
		memcpy(mem,p,mcat->mc_mlen);
		ret = 0;
	}
	return ret;
}

/****************************************/
/*	60									*/
/****************************************/
void akxs_xmseq_free(mcat2)
MCAT2 *mcat2;
{
	if (mcat2) {
		akxtleaffree(mcat2);
	}
	return;
}

/*	61	*/
/********1*********2*********3*********4*********5*********6*********7***/
/* @\ : Œ蒷R[hǗ\̂𐶐						*/
/*  : IN  : mlen		: R[h(L[{f[^)(oCg)		*/
/*				imax_rec	: ő僌R[h							*/
/*							  imax<=0̂Ƃ́A10				*/
/*				dlen 		: f[^(oCg)						*/
/*				m_alloc		: mۊ֐(=NULL:mallocg)		*/
/*				pConstCt	: ConstCtւ̃|C^(=NULL:ConstCtgp)	*/
/*		  OUT : Ȃ													*/
/* ԋp :	<>MULL : Ǘ\̂ւ̃|C^						*/
/*			= NULL : G[												*/
/* 쐬 : 2023/05/31 Aki to Kobayashi									*/
/* XV : 																*/
/************************************************************************/
MCAT2 *akxs_mseq2_new(mlen,imax_rec,dlen,m_alloc,pConstCt)
int mlen,imax_rec,dlen;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	MCAT2_ELM *p;
	int int_max_mlen,imax,extent;
/*
printf("akxs_mseq2_new:Enter mlen=%d imax_rec=%d dlen=%d m_alloc=%s pConstCt=%s\n",
mlen,imax_rec,dlen,nval1x(m_alloc),nval1x(pConstCt));
*/
	if (dlen < 0) dlen = 0;
	else if (mlen<=0 || dlen>mlen) return NULL;

	if (!(p=(MCAT2_ELM *)akxm_malloc_constct(m_alloc,pConstCt,sizeof(MCAT2)))) {
		errno = -185216101;
		return NULL;
	}
	memset(p,0,sizeof(MCAT2));
	imax = imax_rec;
	if (imax <= 0) {
		imax = -imax;
		if (imax < 5) imax = 10;	/* 256 */
	}
	else {
		int_max_mlen = INT_MAX/mlen;
		if (imax > int_max_mlen) imax = int_max_mlen;
	}
	p->mc_id[0] = 'M';
	p->mc_id[1] = 'S';
	if (imax_rec < 0) {
		if (imax <= 10) extent = imax;
		else if (imax <= 100) extent = 10;
		else {
			extent = imax/10;
		}
	}
	else {
		if (imax_rec > 0) p->mc_maxrec = imax;
		extent = imax/USHRT_MAX;
		if (extent <= 0) extent = 2;
	}
	if (extent > USHRT_MAX) extent = USHRT_MAX;
	p->mc_extlen = extent;
	p->mc_malloc = m_alloc;
	p->mc_constct = pConstCt;
	p->mc_mlen = mlen;
	p->mc_resv = dlen;
/*
printf("akxs_mseq2_new:Exit imax=%d extent=%d p=%08x\n",imax,extent,p);
*/
	return (MCAT2 *)p;
}

/****************************************/
/*	62									*/
/****************************************/
MCAT2 *akxs_mseq_new(mlen,imax,m_alloc,pConstCt)
int mlen,imax;
char *(*m_alloc)();
tdtCONSTCT *pConstCt;
{
	return akxs_mseq2_new(mlen,imax,0,m_alloc,pConstCt);
}

/****************************************/
/*	63									*/
/****************************************/
int akxs_mseq_i(mcat)
MCAT2 *mcat;
{
	int ret;

	ret = 0;
	if (mcat) mcat->mc_ipos = 0;
	else ret = -1;
	return ret;
}

/*	64	*/
/********1*********2*********3*********4*********5*********6*********7***/
/* @\ : ɃR[hZbg								*/
/*  : IN  : mcat	: Œ蒷R[hǗ\̂ւ̃|C^	*/
/*				ilay	: ݒʒu										*/
/*						  <= 0 : ɒǉ							*/
/*						  >  0 : R[hʒu(1擪)					*/
/*								 Zbgςݍő僌R[hԍz		*/
/*								 Ƃ́AG[						*/
/*				mem 	: Zbg郌R[h							*/
/*		  OUT : mcat	:												*/
/*							mc_alclen : Œ蒷vf				*/
/*							mc_bufp   ; Œ蒷̈̐擪AhX	*/
/*							mc_ipos   : R[hʒu(1擪)		*/
/* ԋp : > 0 : ZbgR[hԍ(1擪)							*/
/*		  < 0 : G[													*/
/* 쐬 : 2023/05/31 Aki to Kobayashi									*/
/* XV : 																*/
/************************************************************************/
int akxs_mseq_set(mcat,ilay,mem)
MCAT2_ELM *mcat;
int ilay;
char *mem;
{
	int pos,ii,mlen,alen,maxrec,extent,alclen,ilay0;
	char *p,*pp;
/*
printf("akxs_mseq_set:Enter mcat=%08x ilay=%d\n",mcat,ilay);
*/
	if (!mcat) return -1;

	maxrec = mcat->mc_maxrec;
/*
printf("akxs_mseq_set: maxrec=%d\n",maxrec);
*/
	ilay0 = ilay;
	if (ilay <= 0) ilay = mcat->mc_ipos;
	if (maxrec && ilay>=maxrec) return -2;
	if (ilay0 > 0) ilay = ilay0 - 1;
	mlen = mcat->mc_mlen;
	alen = mcat-> mc_alclen;
	p = mcat->mc_bufp;
	if (ilay>=alen || !p) {
		extent = mcat->mc_extlen;
		if (!extent) extent = USHRT_MAX;
		alclen = alen + extent;
/*
printf("akxs_mseq_set: alen=%d extent=%d alclen=%d\n",alen,extent,alclen);
*/
		mcat-> mc_alclen = alclen;
		if (!(pp = akxm_malloc_constct(mcat->mc_malloc,mcat->mc_constct,alclen*mlen))) return -1;
		if (p) {
			if (alen) memcpy(pp,p,alen*mlen);
			if (!mcat->mc_malloc) Free(p);
		}
		mcat->mc_bufp = pp;
		extent += extent;
		if (extent > USHRT_MAX) extent = USHRT_MAX;
		mcat->mc_extlen = extent;
		p = pp;
	}
	pos = ilay*mlen;
	memcpy(p+pos,mem,mlen);
	ii = ilay + 1;
	if (ii > mcat->mc_ipos) {
		mcat->mc_ipos = ii;
	}
/*
printf("akxs_mseq_set:Exit ii=%d\n",ii);
*/
	return ii;
}

/*	65	*/
/********1*********2*********3*********4*********5*********6*********/
/* @\ : ɎwL[ŃT[`							*/
/*  : IN  : mcat : Œ蒷R[hǗ\̂ւ̃|C^	*/
/*				mem  : L[   : T[`L[ݒ肷				*/
/*					   f[^ : f[^Ԃ					*/
/*				opt  : 												*/
/*					  =0x01 : ȂƂmem̃f[^	*/
/*							  NA							*/
/*					  =0x02 : Ƃf[^ǂݍ܂Ȃ	*/
/*					  =0x10 : strcmpA								*/
/* ԋp : > 0 : R[hԍ(1擪)						*/
/*		  = 0 : Ȃ									*/
/*		  < 0 : G[												*/
/* 쐬 : 2023/05/31 Aki to Kobayashi								*/
/* XV : 															*/
/********************************************************************/
int akxs_mseq_r2(mcat,mem,opt)
MCAT2 *mcat;
char *mem;
int opt;
{
	int i,ii,mlen,dlen,klen,opt10,match,maxrec;
	char *p;
/*
printf("akxs_mseq_r2:Enter mcat=%08x opt=%02x\n",mcat,opt);
*/
	if (!mcat || !mem) return -1;

	if (!(p = mcat->mc_bufp)) {
/*
printf("akxs_mseq_r2:Exit p=NULL ii=%d\n",ii);
*/
		return 0;
	}
	opt10 = opt & 0x10;
	mlen = mcat->mc_mlen;
	dlen = mcat->mc_resv;
	klen = mlen - dlen;
	maxrec = mcat->mc_ipos;
/*
printf("akxs_mseq_r2: maxrec=%d\n",maxrec);
*/
	ii = 0;
	for (i=0;i<maxrec;i++) {
		if (opt10) match = !strcmp(p,mem);
		else match = !memcmp(p,mem,klen);
		if (match) {
/*
printf("akxs_mseq_r2: i=%d\n",i);
*/
			ii = i + 1;
			break;
		}
		p += mlen;
	}
	if (dlen > 0) {
		if (ii > 0) {
			if (!(opt & 0x02)) memcpy(mem+klen,p+klen,dlen);
		}
		else if (opt & 0x01) memset(mem+klen,0,dlen);
	}
/*
printf("akxs_mseq_r2:Exit ii=%d\n",ii);
*/
	return ii;
}

/* 66 */
/********1*********2*********3*********4*********5***/
/*		mem	: L[   : T[`L[ݒ肷		*/
/* ԋp : > 0 : R[hԍ(1擪)		*/
/*				f[^Ԃ						*/
/*		  = 0 : Ȃ					*/
/*				f[^NA				*/
/*		  < 0 : G[								*/
/****************************************************/
int akxs_mseq_r(mcat,mem)
MCAT2 *mcat;
char *mem;
{
	return akxs_mseq_r2(mcat,mem,1);
}

/****************************************/
/*	67									*/
/****************************************/
int akxs_mseq_s(mcat,mem)
MCAT2 *mcat;
char *mem;
{
	int ii;

	if (!mcat || !mem) return -1;

	if ((ii=akxs_mseq_r2(mcat,mem,2)) >= 0) {
		if (!ii) ii = -1;
		ii = akxs_mseq_set(mcat,ii,mem);
	}
	return ii;
}

/*	68	*/
/********1*********2*********3*********4*********5*******/
/*  : IN  : ilay	: 擾/폜ʒu					*/
/*						  <= 0 : ̃R[h			*/
/*						  >  0 : R[hʒu(1擪)	*/
/* ԋp : > 0 : R[hԍ(1擪)			*/
/*		  = 0 : Ȃ						*/
/*		  < 0 : G[									*/
/********************************************************/
int akxs_mseq_get_del(mcat,ilay,mem,del)
MCAT2 *mcat;
int ilay,del;
char *mem;
{
	int ret,mlen,max_lay;
	char *p,*pp;
/*
printf("akxs_mseq_get:Enter mcat=%08x ilay=%d\n",mcat,ilay);
*/
	if (!mcat || !mem) return -1;

	ret = 0;
	if (p=mcat->mc_bufp) {
		max_lay = mcat->mc_ipos;
		if (ilay <= 0) ilay = max_lay;
		ilay--;
		max_lay--;
		if (ilay>=0 && ilay<=max_lay) {
			mlen = mcat->mc_mlen;
			pp = p + ilay*mlen;
			memcpy(mem,pp,mlen);
			if (del) {
				if (max_lay > ilay) memcpy(pp,pp+mlen,(max_lay-ilay)*mlen);
				memset(pp,0,mlen);
				mcat->mc_ipos--;
			}
			ret = ilay + 1;
		}
	}
	return ret;
}

/*	69	*/
/********1*********2*********3*********4*********5*******/
/*  : IN  : ilay	: 擾ʒu						*/
/*						  <= 0 : ̃R[h			*/
/*						  >  0 : R[hʒu(1擪)	*/
/* ԋp : > 0 : R[hԍ(1擪)			*/
/*		  = 0 : Ȃ						*/
/*		  < 0 : G[									*/
/********************************************************/
int akxs_mseq_get(mcat,ilay,mem)
MCAT2 *mcat;
int ilay;
char *mem;
{
	return akxs_mseq_get_del(mcat,ilay,mem,0);
}

/*	70	*/
/********1*********2*********3*********4*********5*******/
/*  : IN  : ilay	: 폜ʒu						*/
/*						  <= 0 : ̃R[h			*/
/*						  >  0 : R[hʒu(1擪)	*/
/* ԋp : > 0 : R[hԍ(1擪)			*/
/*		  = 0 : Ȃ						*/
/*		  < 0 : G[									*/
/********************************************************/
int akxs_mseq_del(mcat,ilay,mem)
MCAT2 *mcat;
int ilay;
char *mem;
{
	return akxs_mseq_get_del(mcat,ilay,mem,1);
}

/****************************************/
/*	71									*/
/****************************************/
void akxs_mseq_free(mcat2)
MCAT2 *mcat2;
{
	if (mcat2) {
		if (!mcat2->mc_malloc) {
			Free(mcat2->mc_bufp);
			Free(mcat2);
		}
	}
	return;
}
